// Sprocket Framework header file
// Sprocket.h

#ifndef		_SPROCKET_
#define		_SPROCKET_

#ifndef		__CONDITIONALMACROS__
	#include	<ConditionalMacros.h>
#endif

#include	"Preferences.h"
#include	"MenuBar.h"
#include	"Window.h"
#include	"SplashWindow.h"

#include	"SprocketConstants.h"
#include	"SprocketMacros.h"

#if	qUseQuickDrawGX
	#include	<FixMath.h>			//	make sure we dont use GX's lame #define of fixed1
	#include	<GXTypes.h>
#endif

#if	qAOCEAware
	#ifndef __OCESTANDARDMAIL__
		#include	<OCEStandardMail.h>
	#endif
#endif

#ifdef SMPInitMailer
	#define	qPowerTalkSystemSupport		1
#else
	#define	qPowerTalkSystemSupport		0
#endif

//	Private functions provided by Sprocket:

void		HandleEvent(EventRecord *anEvent);		// Handle one event
void		HandleClose(WindowRef aWindow);			// Close one window
OSErr		QueueCommand(CommandID command);		// Put one command in the queue
													// Do not call this function directly,
													// use SendCommandToSelf() instead.
#if  qAOCEAware && qPowerTalkSystemSupport
//	AOCE FrontWindow-equivalent routine for the Standard Mail package
extern FrontWindowUPP	FrontWindowProcForAOCEUPP;
#endif

//	Globals

extern	Boolean				gDone;
extern	TMenuBar*			gMenuBar;
extern	TSplashWindow*		gSplashWindow;

extern	long				gSystemVersion;
extern	Boolean				gHasColorQuickdraw;
extern	Boolean				gHasThreadManager;
extern	Boolean				gHasDragManager;
extern	Boolean				gHasAppleScript;
extern	Boolean				gHasAOCE;
extern	Boolean				gHasDisplayManager;
extern	Boolean				gHasSpeechManager;
extern	Boolean				gHasSpeechRecognitionManager;
extern	Boolean				gHasAppleGuide;

#if	qInlineInputAware
extern	Boolean				gHasTextServices;
extern	Boolean				gHasTSMTE;
#endif

#if	qUseQuickDrawGX
extern	Boolean				gHasQuickDrawGX;
extern	long				gQuickDrawGXVersion;
extern	long				gQuickDrawGXPrintingVersion;
extern	gxGraphicsClient	gQuickDrawGXClient;
#endif

extern	GrafPtr				gWindowManagerPort;
extern	Rect				gDeskRectangle;
extern	RgnHandle			gMouseRegion;


/////////////////////////////////////////////////////////////////
//
//	Routines that the application MUST supply:


//	Intialization & tear down:

extern	OSErr	SetupApplication(void);
extern	void	TearDownApplication(void);


//	Scrap coercion hooks:

extern	void	WriteLocalClipboardToScrap(void);
extern	void	ReadLocalClipboardFromScrap(void);


//	Document handling routines:

extern	OSErr	CreateNewDocument(void);
extern	OSErr	OpenDocument(FSSpec*, void*);
extern	OSErr	PrintDocument(FSSpec*, void*);
extern	Boolean	QuitApplication(void);


//	Menu Handling

extern	void	HandleCommand(CommandID theCommand);
extern	void	HandleMenuSelection(MenuID theMenu, MenuItemID theItem);

#endif